/* xl_cheeselooks theme engine
 * Copyright (C) 2005 Richard Stellingwerff
 * Copyright (C) 2007 Benjamin Berg
 * Copyright (C) 2007 Andrea Cimitan
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 * Written by Owen Taylor <otaylor@redhat.com>
 * and by Alexander Larsson <alexl@redhat.com>
 * Modified by Richard Stellingwerff <remenic@gmail.com>
 * Modified by Kulyk Nazar <schamane@myeburg.net>
 */

#include <gtk/gtkrc.h>
#include "xl_cheeselooks_types.h"

typedef struct _xl_cheeselooksRcStyle xl_cheeselooksRcStyle;
typedef struct _xl_cheeselooksRcStyleClass xl_cheeselooksRcStyleClass;

GE_INTERNAL extern GType xl_cheeselooks_type_rc_style;

#define xl_cheeselooks_TYPE_RC_STYLE              xl_cheeselooks_type_rc_style
#define xl_cheeselooks_RC_STYLE(object)           (G_TYPE_CHECK_INSTANCE_CAST ((object), xl_cheeselooks_TYPE_RC_STYLE, xl_cheeselooksRcStyle))
#define xl_cheeselooks_RC_STYLE_CLASS(klass)      (G_TYPE_CHECK_CLASS_CAST ((klass), xl_cheeselooks_TYPE_RC_STYLE, xl_cheeselooksRcStyleClass))
#define xl_cheeselooks_IS_RC_STYLE(object)        (G_TYPE_CHECK_INSTANCE_TYPE ((object), xl_cheeselooks_TYPE_RC_STYLE))
#define xl_cheeselooks_IS_RC_STYLE_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), xl_cheeselooks_TYPE_RC_STYLE))
#define xl_cheeselooks_RC_STYLE_GET_CLASS(obj)    (G_TYPE_INSTANCE_GET_CLASS ((obj), xl_cheeselooks_TYPE_RC_STYLE, xl_cheeselooksRcStyleClass))

/* XXX: needs fixing! */
typedef enum {
	CL_FLAG_STYLE              = 1 <<  0,
	CL_FLAG_FOCUS_COLOR        = 1 <<  1,
	CL_FLAG_SCROLLBAR_COLOR    = 1 <<  2,
	CL_FLAG_COLORIZE_SCROLLBAR = 1 <<  3,
	CL_FLAG_CONTRAST           = 1 <<  4,
	CL_FLAG_RELIEFSTYLE        = 1 <<  5,
	CL_FLAG_MENUBARSTYLE       = 1 <<  6,
	CL_FLAG_TOOLBARSTYLE       = 1 <<  7,
	CL_FLAG_ANIMATION          = 1 <<  8,
	CL_FLAG_RADIUS             = 1 <<  9,
	CL_FLAG_HINT               = 1 <<  10
} xl_cheeselooksRcFlags;


struct _xl_cheeselooksRcStyle
{
	GtkRcStyle parent_instance;

	xl_cheeselooksRcFlags flags;

	xl_cheeselooksStyles style;

	GdkColor focus_color;
	GdkColor scrollbar_color;
	gboolean colorize_scrollbar;
	double contrast;
	guint8 reliefstyle;
	guint8 menubarstyle;
	guint8 toolbarstyle;
	gboolean animation;
	double radius;
	GQuark hint;
};

struct _xl_cheeselooksRcStyleClass
{
	GtkRcStyleClass parent_class;
};

GE_INTERNAL void xl_cheeselooks_rc_style_register_type (GTypeModule *module);
