/* xl_cheeselooks theme engine
 * Copyright (C) 2005 Richard Stellingwerff.
 * Copyright (C) 2007 Benjamin Berg
 * Copyright (C) 2007 Andrea Cimitan
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 * Written by Owen Taylor <otaylor@redhat.com>
 * and by Alexander Larsson <alexl@redhat.com>
 * Modified by Richard Stellingwerff <remenic@gmail.com>
 */
 
#include <gtk/gtkstyle.h>

#ifndef xl_cheeselooks_STYLE_H
#define xl_cheeselooks_STYLE_H

#include "animation.h"
#include "xl_cheeselooks_types.h"

typedef struct _xl_cheeselooksStyle xl_cheeselooksStyle;
typedef struct _xl_cheeselooksStyleClass xl_cheeselooksStyleClass;

GE_INTERNAL extern GType xl_cheeselooks_type_style;

#define xl_cheeselooks_TYPE_STYLE              xl_cheeselooks_type_style
#define xl_cheeselooks_STYLE(object)           (G_TYPE_CHECK_INSTANCE_CAST ((object), xl_cheeselooks_TYPE_STYLE, xl_cheeselooksStyle))
#define xl_cheeselooks_STYLE_CLASS(klass)      (G_TYPE_CHECK_CLASS_CAST ((klass), xl_cheeselooks_TYPE_STYLE, xl_cheeselooksStyleClass))
#define xl_cheeselooks_IS_STYLE(object)        (G_TYPE_CHECK_INSTANCE_TYPE ((object), xl_cheeselooks_TYPE_STYLE))
#define xl_cheeselooks_IS_STYLE_CLASS(klass)   (G_TYPE_CHECK_CLASS_TYPE ((klass), xl_cheeselooks_TYPE_STYLE))
#define xl_cheeselooks_STYLE_GET_CLASS(obj)    (G_TYPE_INSTANCE_GET_CLASS ((obj), xl_cheeselooks_TYPE_STYLE, xl_cheeselooksStyleClass))

struct _xl_cheeselooksStyle
{
	GtkStyle parent_instance;

	xl_cheeselooksColors colors;

	xl_cheeselooksStyles style;

	guint8   reliefstyle;
	guint8   menubarstyle;
	guint8   toolbarstyle;
	GdkColor focus_color;
	gboolean has_focus_color;
	GdkColor scrollbar_color;
	gboolean colorize_scrollbar;
	gboolean has_scrollbar_color;
	gboolean animation;
	gfloat   radius;
};

struct _xl_cheeselooksStyleClass
{
	GtkStyleClass parent_class;

	xl_cheeselooksStyleFunctions style_functions[CL_NUM_STYLES];
};

GE_INTERNAL void xl_cheeselooks_style_register_type (GTypeModule *module);

#endif /* xl_cheeselooks_STYLE_H */
